
<?= $element->renderSubmenu('/1-lekce-zaklady'); ?>

<h1 class="mainTitle"><?= $template->title; ?></h1>

<h2>Co je PHP a k čemu se používá</h2>
<p>
	<strong>PHP</strong>: Hypertext Preprocessor, původně Personal Home Page je skriptovací programovací jazyk.
	Je určený především pro programování dynamických internetových stránek a webových aplikací.
	Více na <a href="https://cs.wikipedia.org/wiki/PHP" target="_blank">wikipedii</a>.
</p>

<p>
	PHP se vyvýjí jako každý jiný program. PHP nebylo původně psáno jako objektový jazyk.
	V nejnovějších verzích je větší a větší <strong>podpora rysů Objektově orientovaných jazyků</strong> jako je například Java, ze které je dokonce inspirován.
</p>

<p>Pomocí různých knihoven a rozšíření <b>umí</b> PHP pracovat a zpracovávat <b>obrázky</b>, <b>xml</b>, <b>json</b>, <b>databáze</b>, &hellip; a mnoho dalšího, třeba i posílání e-mailů</p>

<p>Jak bylo zmíněno, PHP má verze. A ne vše funguje ve všech verzích. My se ale budeme učit tak, aby to fungovalo všude.</p>

<p>Nikdo neví vše, a proto existuje oficiální <b>dokumentace</b> ke všemu co lze v PHP použít - <a href="http://php.net/docs.php" target="_blank">php.net</a></p>

<h2 class="mainTitle">Základní konstrukce v PHP</h2>

<h3 id="zacatky-v-php">Jak píšeme PHP kód</h3>
<p>
	Každý PHP soubor končí koncovkou <b class="text-pink-dark">.php</b> (<b>soubor.php</b>).
	Není to ale pravidlo, kostrukce jazyka PHP můžeme mít i v souboru s jinou koncovkou. Například když kombinujeme PHP a HTML můžeme souboru dát koncovku <b>.phtml</b>.
</p>
<p>
	Pokud chceme zapsat PHP kód musíme jej uvodit touto značkou <b class="text-pink-dark">&lt;?php</b>.
	Ukončení PHP syntaxe je pak pomocí značky <b class="text-pink-dark">?&gt;</b>.<br>
	Povolená je i zkrácená verze otevírací značky, tzv. shortag - <b class="text-pink-dark">&lt;?</b>. Tu je ale nutné povolit v nastavení PHP,  jinak nebude fungovat.
</p>

<pre class="php">
&lt;?php

?&gt;
</pre>

<h3>Ukončení řádku</h3>
<p>Řádky se v PHP ukončují středníkem <b class="text-pink-dark">;</b> .</p>


<h3>Doporučení pro psaní kódu</h3>
<p>V PHP mezery, odsazení, kód na více řádků a ani komentář nemá vliv na kód. Všechen tento prostor se ignoruje. Proto doporučuji:</p>
<ul>
	<li>odsazujte vnořené bloky a udržujte čitelnost kódu</li>
	<li>pište si komentáře, abyste i za půl roku věděli, proč tu je ta podmínka</li>
</ul>


<h3>Komentáře</h3>
<p>V PHP máme 2 typy komentářů - jednořádkové a víceřádkové.</p>

<h4>Jednořádkové</h4>
<pre class="php">
&lt;?php
    <span class="php__comment">// jednořádkový komentář</span>
?&gt;
</pre>

<h4>Víceřádkové</h4>
<pre class="php">
&lt;?php
    <span class="php__comment">/*</span>
    <span class="php__comment">komentář na</span>
    <span class="php__comment">více řádků</span>
    <span class="php__comment">*/</span>
?&gt;
</pre>


<h3>Vytvoření proměnné</h3>
<p>Proměnou vytvoříme tak, že napíšeme <b class="text-pink-dark">$</b> a poté její jméno.</p>

<pre class="php">
&lt;?php
    <span class="php__var">$nazevPromenne</span>;
?&gt;
</pre>

<p>Přiřazení hodnoty do proměnné je pomocí <b class="text-pink-dark">=</b>.</p>

<pre class="php">
&lt;?php
    <span class="php__var">$nazevPromenne</span> = hodnota;
?&gt;
</pre>


<h3>Výpis obsahu</h3>
<p>
	Když v PHP chceme něco vypsat (například do prohlížeče) použijeme k tomu <b class="text-pink-dark">echo</b>.<br>
	Někdy se můžete setkat i se zápisem, kdy za touto konstrukcí "echo" následují závorky. Obě tyto možnosti jsou správné a povolené.
</p>

<pre class="php">
&lt;?php
    <span class="php__syntax">echo</span> <span class="php__var">$promenna</span>;
    <span class="php__syntax">echo</span>(<span class="php__var">$promenna</span>);
?&gt;
</pre>

<p>Když kombinujeme v jednom souboru PHP a HTML máme možnost použít i zkrácený výpis proměnné <b class="text-pink-dark">&lt;?=</b> místo <b class="text-pink-dark">echo</b> takto:</p>

<pre class="php">
<span class="font-normal">&lt;!DOCTYPE html&gt;</span>
<span class="font-normal">&lt;html lang="cs"&gt;</span>
    <span class="font-normal">&lt;head&gt;</span>
        <span class="font-normal">&lt;meta charset="utf-8"&gt;</span>
        <span class="font-normal">&lt;title&gt;</span><span class="text-pink-dark">&lt;?=</span> <span class="php__var">$promenna;</span> <span class="text-pink-dark">?&gt;</span><span class="font-normal">&lt;/title&gt;</span>
</pre>

<h3>Tip pro pokročilejší</h3>

<p>
	Existují ale i situace, kdy potřebujeme (nebo chceme) vypsat i složitější datové typy, které pomocí konstrukce "echo" vypsat nemůže.
	Typicky to jsou například celá pole nebo objekty. Pro tyto účely můžeme použít <b class="text-pink-dark">print_r</b>. Zde už jsou závorky nutné.
</p>
<pre class="php">
&lt;?php
    <span class="php__syntax">print_r</span>(<span class="php__var">$promenna</span>);
?&gt;
</pre>


<h4>Pravidla pro psaní proměnných</h4>
<p>V PHP tak jako i v jiných jazycích mají pouze 2 základní pravidla:</p>

<ul>
	<li>proměnné <b>nesmějí</b> obsahovat diakritiku</li>
	<li>proměnné <b>nesmějí</b> obsahovat mezery</li>
	<li>proměnné <b>nesmějí</b> začínat číslicí</li>
</ul>

<p>Poté se ještě můžete setkat s těmito doporučeními/možnostmi:</p>
<ul>
	<li>proměnné začínají malým písmenem</li>
	<li>při víceslovných proměnných můžete psát <b>camel<span class="text-pink-dark">Case</span></b> - <b>pocet<span class="text-pink-dark">Hodin</span></b></li>
	<li>název proměnné by měl dávat smysl a vyjadřovat její obsah</li>
</ul>


<h2 class="mainTitle" id="datove-typy">Datové typy</h2>

<p>V jazyku PHP máme několik základních datových typů. Jsou to tyto:</p>
<ul>
	<li><a href="#string">řetězec</a></li>
	<li><a href="#int">celé číslo</a></li>
	<li><a href="#float">desetinné číslo</a></li>
	<li><a href="#bool">pravdivostní hodnota</a></li>
	<li><a href="#array">pole</a></li>
	<li><a href="#std">objekt</a></li>
	<li><a href="#null">žádná hodnota</a></li>
</ul>


<h3 id="string">Řetězec</h3>
<p>Řetezci se v PHP říká <b>string</b>. Řetězec je posloupnost znaků. Tuto posloupnost píšeme do uvozovek. Můžeme použít jednoduché <b class="text-pink-dark">'</b> nebo dvojité <b class="text-pink-dark">"</b>.</p>
<p>Řetězce se v PHP spojují pomíc tečky <b class="text-pink-dark">.</b></p>

<pre class="php">
&lt;?php
    <span class="php__var">$retezec1</span> = <span class="php__str">'Ahoj'</span>;
    <span class="php__var">$retezec2</span> = <span class="php__str">"Světe !!!"</span>;
    <span class="php__syntax">echo</span> <span class="php__var">$retezec1</span> . <span class="php__str">' '</span> . <span class="php__var">$retezec1</span>; <span class="php__comment">// Vypíše se: Ahoj Světe !!!</span>
?&gt;
</pre>

<h4>Tip pro pokročilejší</h4>
<p>Pokud při výpisu řetězce použijeme dvojité uvozovky, můžeme poté proměnnou vypsat následujícím způsobem:</p>

<pre class="php">
&lt;?php
    <span class="php__var">$retezec</span> = <span class="php__str">'Ahoj'</span>;
    <span class="php__syntax">echo</span> <span class="php__str">"<span class="php__var">{$retezec}</span> Jindro."</span>; <span class="php__comment">// Vypíše se: Ahoj Jindro.</span>
?&gt;
</pre>


<h3 id="int">Celé číslo</h3>
<p>Celému číslu se v PHP říká <b>integer</b>, někdy také jenom <b>int</b>.</p>

<pre class="php">
&lt;?php
    <span class="php__var">$cislo</span> = <span class="php__num">10</span>;
?&gt;
</pre>


<h3 id="float">Desetinné číslo</h3>
<p>Desetinnému číslu se v PHP říká <b>float</b>. V PHP se jako oddělovač desetinného rozvoje používá <b class="text-pink-dark">.</b> (<b>tečka</b>).</p>

<pre class="php">
&lt;?php
    <span class="php__var">$cisloSDesetinnymMistem</span> = <span class="php__num">3</span><span class="php__syntax">.</span><span class="php__num">14</span>;
?&gt;
</pre>

<h3>Matematické operace</h3>
<p>Když už známe čísla, podívejme se jaké základní matematické operace s nimi můžeme dělat:</p>

<pre class="php">
&lt;?php
    <span class="php__comment">// sčítání - výsledek bude 14</span>
    <span class="php__syntax">echo</span> <span class="php__num">5</span> + <span class="php__num">9</span>;

    <span class="php__comment">// odčítání - výsledek bude -69</span>
    <span class="php__syntax">echo</span> <span class="php__num">9</span> - <span class="php__num">78</span>;

    <span class="php__comment">// násobení - výsledek bude 25</span>
    <span class="php__syntax">echo</span> <span class="php__num">5</span> * <span class="php__num">5</span>;

    <span class="php__comment">// dělení - výsledek bude 2.5</span>
    <span class="php__syntax">echo</span> <span class="php__num">10</span> / <span class="php__num">4</span>;

    <span class="php__comment">// zbytek po celočíselném dělení - výsledek bude 2</span>
    <span class="php__syntax">echo</span> <span class="php__num">17</span> % <span class="php__num">5</span>;
?&gt;
</pre>


<h3 id="bool">Pravdivostní hodnota (Logický datový typ)</h3>
<p>
	Pravdivostní hodnotě se v PHP říká <b>boolean</b>, někdy také jenom <b>bool</b>. Tento datový typ má pouze 2 hodnoty (<b>TRUE</b>, <b>FALSE</b>).<br>
	<b>TRUE</b> - pravda (její číselná hodnota je 1)<br>
	<b>FALSE</b> - nepravda (její číselná hodnota je 0)
</p>

<pre class="php">
&lt;?php
    <span class="php__var">$pravda</span> = <span class="php__syntax">TRUE</span>;
    <span class="php__var">$nepravda</span> = <span class="php__syntax">FALSE</span>;
?&gt;
</pre>


<h3 id="array">Pole (seznam hodnot)</h3>
<p>Poli se v PHP říká <b>array</b>. Do pole (seznamu hodnot) můžeme vložit nekonečné mnoštví hodnot. Tyto hodnoty mohou být jakéhokoliv datového typu.</p>
<ul>
	<li>každá hodnota v poli má svůj <b>index</b> (klíč), pomocí něhož se dostaneme k dané hodnotě</li>
	<li>hodnoty se oddělují <b>čárkou</b></li>
	<li>pokud do pole vložíme pouze hodnoty, indexy jsou celá čísla a první prvek má index <b>0</b></li>
	<li>při vytváření pole si můžeme klíče nadefinovat <b>sami</b>, takovému poli poté říkáme <b>asociativní</b> pole</li>
</ul>

<pre class="php">
&lt;?php
    <span class="php__var">$nakupniSeznam</span> = <span class="php__syntax">array</span>(<span class="php__str">'paprika'</span>, <span class="php__str">'okurka'</span>, <span class="php__str">'česnek'</span>);

    <span class="php__var">$satnik</span> = <span class="php__syntax">array</span>(
        <span class="php__str">'policka1'</span> => <span class="php__syntax">array</span>(<span  class="php__str">'čepice'</span>, <span  class="php__str">'šály'</span>),
        <span class="php__str">'policka2'</span> => <span class="php__syntax">array</span>(<span  class="php__str">'kapesníky'</span>, <span  class="php__str">'papírové kapesníky'</span>),
        <span class="php__str">'tycNaRaminka'</span> => <span class="php__syntax">array</span>(<span  class="php__str">'tričko'</span>, <span  class="php__str">'bunda'</span>, <span  class="php__str">'černé tričko'</span>),
    );
?&gt;
</pre>

<div class="tip">
	<div class="tip__title"><b>Tip:</b></div>
	<p class="tip__text">
		Za posledním prvkem pole (satnik) můžete vidět čárku. To není chyba. Syntaxe jazyka to dovoluje.
		Já ji tam píšu, protože když za tam za 2 měsíce přidám další hodnotu (nebo když změním pořádí), tak nemusím myslet na to, jestli tam je nebo ne.
	</p>
</div>

<p>Získání hodnoty z pole na určité <b>pozici/indexu</b>. Nezapomeňte, že v neasociativním poli indexy začínají od <b>0</b>.</p>
<pre class="php">
&lt;?php
    <span class="php__syntax">echo</span> <span class="php__var">$nakupniSeznam</span>[<span class="php__num">1</span>];		<span class="php__comment">// hodnota bude: okurka</span>
    <span class="php__syntax">print_r</span>(<span class="php__var">$satnik</span>[<span class="php__str">'policka1'</span>]);	<span class="php__comment">// hodnota bude pole na tomto indexu</span>
    <span class="php__syntax">echo</span> <span class="php__var">$satnik</span>[<span class="php__str">'tycNaRaminka'</span>][<span class="php__num">2</span>];	<span class="php__comment">// hodnota bude: černé tričko</span>
?&gt;
</pre>


<h3>Práce s polem</h3>

<pre class="php">
&lt;?php
    <span class="php__var">$pole</span> = <span class="php__syntax">array</span>();			<span class="php__comment">// pokud chceme vytvořit prázdné pole</span>

    <span class="php__var"><span class="php__var">$nakupniSeznam</span>[<span class="php__num">1</span>];</span> = <span class="php__str">'rajče'</span>;	<span class="php__comment">// přepsání hodnoty na indexu 1 - z okurky bude rajče</span>

    <span class="php__var"><span class="php__var">$nakupniSeznam</span>[]</span> = <span class="php__str">'chleba'</span>;	<span class="php__comment">// přidání další hodnoty do pole (na konec pole) - index chlebu bude 3</span>

    <span class="php__var"><span class="php__var">$nakupniSeznam</span>[<span class="php__num">10</span>]</span> = <span class="php__str">'rohlík'</span>;	<span class="php__comment">// přidání další hodnoty na daný index</span>

    <span class="php__var">$satnik</span>[<span class="php__str">'policka3'</span>] = <span class="php__str">'ručníky'</span>;<span class="php__comment">	// přidání další hodnoty do pole s indexem policka3</span>
?&gt;
</pre>


<h3 id="std">Objekt</h3>
<p>Objekt je velmi podobný poli. Rozdíl je v jeho zápisu. U objektu také <b>nesmí</b> název klíče začínat číslicí.</p>

<p>Pokud chceme použít datový typ objekt, musíme jej nejdříve vytvořit.</p>

<pre class="php">
&lt;?php
    <span class="php__comment">// vytvoření prázdného objektu</span>
    <span class="php__var">$satnik</span> = <span class="php__syntax">new</span> <span class="php__obj">stdClass</span>();

    <span class="php__comment">// naplění objektu daty</span>
    <span class="php__var">$satnik</span>-><span class="php__obj">policka1</span> = <span class="php__syntax">array</span>(<span class="php__str">'čepice'</span>, <span class="php__str">'šály'</span>);
    <span class="php__var">$satnik</span>-><span class="php__obj">policka2</span> = <span class="php__syntax">array</span>(<span class="php__str">'kapesníky'</span>, <span class="php__str">'papírové kapesníky'</span>);
    <span class="php__var">$satnik</span>-><span class="php__obj">tycNaRaminka</span> = <span class="php__syntax">array</span>(<span class="php__str">'tričko'</span>, <span class="php__str">'bunda'</span>, <span class="php__str">'černé tričko'</span>);
?&gt;
</pre>

<p>Přístup k hodnotám je poté následující:</p>
<pre class="php">
&lt;?php
    <span class="php__syntax">print_r</span>(<span class="php__var">$satnik</span>-><span class="php__obj">policka1</span>);	<span class="php__comment">// hodnota bude pole na tomto indexu</span>
    <span class="php__syntax">echo</span> <span class="php__var">$satnik</span>-><span class="php__obj">policka1</span>[<span class="php__num">0</span>];	<span class="php__comment">// hodnota bude: čepice</span>
?&gt;
</pre>

<h3 id="null">Žádná hodnota (NULL)</h3>
<p>
	Jedná se o specální hodnotu. Když chceme vytvořit (inicializovat) proměnnou, ale nechceme do ní ihned vložit hodnotu.<br>
	Použití poté můžeme vidět v další lekci - <a href="/2-lekce-podminky">podmínky</a>.
</p>
<pre class="php">
&lt;?php
    <span class="php__var">$promenna</span> = <span class="php__syntax">NULL</span>;
?&gt;
</pre>
